<!doctype html>
<html>

<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no">

    <title>Design Patterns</title>

    <link rel="stylesheet" href="dist/reset.css">
    <link rel="stylesheet" href="dist/reveal.css">
    <link rel="stylesheet" href="dist/theme/black.css" id="theme">

    <script src="dist/reveal.js"></script>
    <script src="plugin/notes/notes.js"></script>
    <script src="plugin/markdown/markdown.js"></script>
    <script src="plugin/highlight/highlight.js"></script>
    <script src="plugin/wordcloud/wordcloud2/src/wordcloud2.js"></script>

    <!-- Theme used for syntax highlighted code -->
    <link rel="stylesheet" href="plugin/highlight/monokai.css" id="highlight-theme">
</head>

<body>
    <div class="reveal">
        <div class="slides">
            <!-- Folie 01 -->
            <section>
                <h1 class="r-fit-text">Design Patterns</h1>
            </section>
            <!-- Folie 02 -->
            <section>
                <section>
                    <h2>Überblick</h2>
                    <blockquote>„Each pattern describes a problem which occurs over and over again in our environment,
                        and then describes the core soliution to that problem, in such a way that you can use this
                        solution a million times over, without ever doing it the same way twice“
                    </blockquote>
                    <p>Christopher Alexander</p>
                </section>
                <section>
                    <h2>Überblick</h2>
                    <p>Was ist ein Design Pattern?<br />
                        Ein wiederkehrendes Muster, welches ein allgemeines Problem löst.</p>
                    <p>Was für Pattern gibt es?<br />
                        Creational, Structural & Behavioral Patterns</p>
                    <p>Was sind ihre Limits?<br />
                        Sie lösen nur genau dieses eine Problem.</p>
                </section>
            </section>
            <!-- Folie 03 -->
            <section>
                <section>
                    <h2>Unterschiede<br />&<br />Anwendungsbreiche<br />–<br />Quick Version</h2>
                </section>
                <section>
                    <h3>Creational Patterns</h3>
                    <p>Dienen der Erzeugung von Objekten. Sie entkoppeln die Konstruktion eines Objekts von seiner
                        Repräsentation. Die Objekterzeugung wird gekapselt und ausgelagert, um den Kontext der
                        Objekterzeugung unabhängig von der konkreten Implementierung zu halten.</p>
                </section>
                <section>
                    <h3>Structural Patterns</h3>
                    <p>Erleichtern den Entwurf von Software durch vorgefertigte Schablonen für Beziehungen zwischen
                        Klassen.</p>
                </section>
                <section>
                    <h3>Behavioral Patterns</h3>
                    <p>Modellieren komplexes Verhalten der Software und erhöhen damit die Flexibilität der Software
                        hinsichtlich ihres Verhaltens.</p>
                </section>
            </section>
            <!-- Folie 04 -->
            <section>
                <h2>Beispiele</h2>
                <ul>
                    <li>In unserem Gitlab<br />
                        <a href="https://gitlab.com/B3-Azubis-18/ifa12b/design-patterns-csharp">Gitlab -
                            B3-Azubis-18/ifa12b/design-patterns-csharp</a>
                    </li>
                    <li>Java<br />
                        <a href="https://github.com/iluwatar/java-design-patterns">Github -
                            iluwater/java-design-patterns</a>
                    </li>
                    <li>C#<br />
                        <a href="https://github.com/RefactoringGuru/design-patterns-csharp">Github -
                            RefactoringGuru/desing-patterns-csharp</a>
                    </li>
                    <li>...</li>
                </ul>
            </section>
            <!-- Folie 05 -->
            <section>
                <section>
                    <h2>Beispiel: Creational Pattern - Abstract Factory</h2>
                    <img src="img/abstract-factory.jpg" />
                </section>
                <section>
                    <h2>Abstract Factory - Factory</h2>
                    <pre>
                            <code data-line-numbers="1-4|6-14|16-24" data-trim data-noescape>
                                public interface IAbstractFactory {
                                    IAbstractProductA CreateProductA();
                                    IAbstractProductB CreateProductB();
                                }
                                
                                class ConcreteFactory1 : IAbstractFactory {
                                    public IAbstractProductA CreateProductA() {
                                        return new ConcreteProductA1();
                                    }
                                
                                    public IAbstractProductB CreateProductB() {
                                        return new ConcreteProductB1();
                                    }
                                }
                                
                                class ConcreteFactory2 : IAbstractFactory {
                                    public IAbstractProductA CreateProductA() {
                                        return new ConcreteProductA2();
                                    }
                                
                                    public IAbstractProductB CreateProductB() {
                                        return new ConcreteProductB2();
                                    }
                                }							
                          </code>
                        </pre>
                </section>
                <section>
                    <h2>Abstract Factory - Product A</h2>
                    <pre>
                        <code data-line-numbers="1-3|5-9|11-15" data-trim data-noescape>
                            public interface IAbstractProductA {
                                string UsefulFunctionA();
                            }
                            
                            class ConcreteProductA1 : IAbstractProductA {
                                public string UsefulFunctionA() {
                                    return "The result of the product A1.";
                                }
                            }
                            
                            class ConcreteProductA2 : IAbstractProductA {
                                public string UsefulFunctionA() {
                                    return "The result of the product A2.";
                                }
                            }
                        </code>
                    </pre>
                </section>
                <section>
                    <h2>Abstract Factory - Product B</h2>
                    <pre>
                        <code data-line-numbers="1-4|6-15|17-26" data-trim data-noescape>
                            public interface IAbstractProductB {
                                string UsefulFunctionB();
                                string AnotherUsefulFunctionB(IAbstractProductA collaborator);
                            }
                            
                            class ConcreteProductB1 : IAbstractProductB {
                                public string UsefulFunctionB() {
                                    return "The result of the product B1.";
                                }
                            
                                public string AnotherUsefulFunctionB(IAbstractProductA collaborator) {
                                    var result = collaborator.UsefulFunctionA();
                                    return $"The result of the B1 collaborating with the ({result})";
                                }
                            }
                            
                            class ConcreteProductB2 : IAbstractProductB {
                                public string UsefulFunctionB() {
                                    return "The result of the product B2.";
                                }
                            
                                public string AnotherUsefulFunctionB(IAbstractProductA collaborator) {
                                    var result = collaborator.UsefulFunctionA();
                                    return $"The result of the B2 collaborating with the ({result})";
                                }
                            }
                        </code>
                    </pre>
                </section>
                <section>
                    <h2>Abstract Factory - Client</h2>
                    <pre>
                        <code data-line-numbers="2-9|11-17" data-trim data-noescape>
                            class Client {
                                public void Main() {
                                    Console.WriteLine("Client: Testing client code with the first factory type...");
                                    ClientMethod(new ConcreteFactory1());
                                    Console.WriteLine();
                            
                                    Console.WriteLine("Client: Testing the same client code with the second factory type...");
                                    ClientMethod(new ConcreteFactory2());
                                }
                            
                                public void ClientMethod(IAbstractFactory factory) {
                                    var productA = factory.CreateProductA();
                                    var productB = factory.CreateProductB();
                            
                                    Console.WriteLine(productB.UsefulFunctionB());
                                    Console.WriteLine(productB.AnotherUsefulFunctionB(productA));
                                }
                            }
                        </code>
                    </pre>
                </section>
            </section>
            <!-- Folie 06 -->
            <section>
                <h2>Structural Patterns</h2>
                <p class="stretch" wordcloud-activate="once"
                    wordcloud='{ "color": "#ffffff", "backgroundColor": "#191919"}'>
                    Adapter
                    Bridge
                    Composite
                    Decorator
                    Facade
                    Flyweight
                    Proxy
                </p>
            </section>
            <!-- Folie 07 -->
            <section>
                <h2>Behavioral Patterns</h2>
                <p class="stretch" wordcloud-activate="once"
                    wordcloud='{ "color": "#ffffff", "backgroundColor": "#191919"}'>
                    Chain of Responsibility
                    Command
                    Interpreter
                    Iterator
                    Mediator
                    Memento
                    Observer
                    State
                    Strategy
                </p>
            </section>
            <!-- Folie 08 -->
            <section>
                <h2>Take Home Message</h2>
                <ul>
                    <li>Es sind theoretische Beispiele!<br />
                        Die echte Welt ist kompliziert...
                    </li>
                    <li>Wir sind keine Software Architekten!<br />
                        Lasst die ihren Job machen, wir sind Fachinformatiker.
                    </li>
                    <li>Lernt es nicht auswendig!<br />
                        Sucht euch Links wie auf der Folie vorhin und schaut lieber nach.
                    </li>
                </ul>
            </section>
            <!-- Folie 09 -->
            <section>
                <h2>Quellen</h2>
                <ul>
                    <li>Design Patterns – Elements of Reusable Object-oriented Software<br />
                        Erich Gamma, Richard Helm, Ralph Johnson, John Vlissides<br />
                        Addison-Wesley & Pearson Education<br />
                        2. Auflage
                    </li>
                    <li><a href="https://de.wikipedia.org/wiki/Entwurfsmuster">Wikipedia - Entwurfsmuster</a></li>
                    </p>
            </section>
        </div>
    </div>

    <script>
        // More info about initialization & config:
        // - https://revealjs.com/initialization/
        // - https://revealjs.com/config/
        Reveal.initialize({
            hash: true,
            width: 1200,
            autoSlide: 5000,
            loop: false,
            slideNumber: true,

            dependencies: [
                {
                    src: 'plugin/wordcloud/reveal-wordcloud.js',
                    condition: function () { return !!document.querySelector('[wordcloud]'); }
                },
            ],

            // Learn about plugins: https://revealjs.com/plugins/
            plugins: [RevealMarkdown, RevealHighlight, RevealNotes]
        });
    </script>
</body>

</html>
